/*
   forward-v4l2-ctrl.h - v4l2 driver controls for SoftLab-NSK Forward video boards

   Copyright (C) 2017 - 2023 Konstantin Oblaukhov <oblaukhov@sl.iae.nsk.su>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef FORWARD_V4L2_CTRL_H
#define FORWARD_V4L2_CTRL_H

#include <forward-v4l2-ioctl.h>

struct forward_v4l2_io;
struct forward_v4l2_io_dev;

int forward_v4l2_ctrl_init_cap(struct forward_v4l2_io_dev *iodev);
int forward_v4l2_ctrl_init_out(struct forward_v4l2_io_dev *iodev);

void forward_v4l2_ctrl_deinit(struct forward_v4l2_io_dev *iodev);

#endif // FORWARD_V4L2_CTRL_H
